react-static-plugin-dev-server
======
A plugin for [React Static](https://react-static.js.org/) that allows you to use [TypeScript](https://www.typescriptlang.org/).

## Installation

```bash
npm install react-static-plugin-typescript @types/react --save-dev
```

## Usage

There are three steps to complete before being able to use this plugin.

First, add the plugin to your `static.config.js`:

```javascript
export default {
  plugins: [
    'react-static-plugin-typescript'
  ]
};
```

Then add a `tsconfig.json`, e.g. this one:

```json
{
  "compilerOptions": {
    "target": "es2015",
    "module": "esnext",
    "lib": ["es2015", "dom"],
    "allowJs": true,
    "jsx": "preserve",
    "sourceMap": true,
    "removeComments": false,
    "strict": true,
    "moduleResolution": "node",
    "baseUrl": "./",
    "paths": {},
    "esModuleInterop": true
  },
  "exclude": [
    "dist/**/*",
    "public/**/*",
    "node_modules"
  ]
}
```

Finally, rename a file from `.js` to `.tsx`. You can then start using TypeScript!

## License

MIT © [Vincent Tunru](https://vincenttunru.com)
