"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
;
exports.default = (function (options) {
    return {
        config: getReactStaticConfigExtender(),
        webpack: getWebpackConfigExtender(options),
    };
});
;
function getWebpackConfigExtender(options) {
    return function (previousConfig, args) {
        var previousModuleConfig = previousConfig.module || {};
        var previousResolveConfig = previousConfig.resolve || {};
        var previousResolveExtensions = previousResolveConfig.extensions || [];
        var typescriptLoader = {
            test: /\.(js|jsx|ts|tsx)$/,
            use: [
                {
                    loader: 'babel-loader',
                },
                {
                    loader: require.resolve('ts-loader'),
                    options: {
                        transpileOnly: true,
                    },
                },
            ],
        };
        return __assign({}, previousConfig, { resolve: __assign({}, previousResolveConfig, { extensions: previousResolveExtensions.concat(['.ts', '.tsx']) }), module: __assign({}, previousModuleConfig, { rules: [{
                        oneOf: [
                            typescriptLoader,
                            args.defaultLoaders.jsLoaderExt,
                            args.defaultLoaders.cssLoader,
                            args.defaultLoaders.fileLoader,
                        ],
                    }] }) });
    };
}
function getReactStaticConfigExtender() {
    return function (previousConfig) {
        return __assign({}, previousConfig, { extensions: previousConfig.extensions.concat(['.ts', '.tsx']) });
    };
}
